/* vc_cpp */

/*
 * Problem:   ROCKS
 * Contest:   UOI-2005 (Rivne)
 * Author:    Bogdan Yakovenko
 * Date:      March, 2005
 * Language:  C++
 * Compiler:  Visual C++ 6.0
 * Algorithm: Algorithm uses special data structures to provide all necessary
 *            info.
 * Remarks: 
 *   This algorithm seems to be correct.
 * 
 *   
 *   
 */

/* Dedicated to (Z) planet*/

#include<fstream>
#include<iostream>
#include<stdio.h>

using namespace std;

//typedef long long lint;
typedef __int64 lint;

const int MAXL = 1024 * 1024/4+10;
int N,L,op,X,H,A,B;
int _x,_y,_sl,_d;
int sss[3*MAXL];
int ppp[3*MAXL]; 
lint S[3*MAXL];

int kol,kol2;

void _realsegm(int x,int y,int M)
{
/*	if(M>kol){kol=M;
	cout << "M = " << M << endl;
	}*/
	if(x == y) return;
//	cout << x <<" " << y << " " << M<<"\n"; 
	if(_x<=x && _y >= y)
	{
		sss[M] += _d+_sl*(x-_x);
		ppp[M] += _sl;

		S[M] += _sl*(((lint)(y-_x))*(y-_x)-((lint)(x-_x))*(x-_x)) + ((lint)2*_d)*(y-x);
//		cout << "X === " << x << " y === " << y << " sss_m = "<< sss[M] <<" M = " << M << endl;
///		cout << "S_m = " << S[M] << endl;
	}
	else if(_y<=x || _x>=y) return;
	else
	{
		int p = (x+y)/2;
		if(x+1 == y) 
		{
//			cout << "H = "<< H;
			return;
		}
		S[M]=S[M]-S[2*M]-S[2*M+1];
		_realsegm(x,p,2*M);
		_realsegm(p,y,2*M+1);
		S[M]=S[M]+S[2*M]+S[2*M+1];
	}
	
}

void addsegm(int x,int y,int sl,int d)
{
	if(x<0)
	{
		d = -x*sl;x = 0;
	}
	if(y>L) y=L;
	_x = x;_y = y; _sl=sl;_d = d;
	_realsegm(0,MAXL-1,1);
	
}

lint evalsegm(int x,int y,int M,int sl,int d)
{
//	cout << "x = " << x << " y = " << y << endl;
	kol2++;
	if(x == y) return 0;
	if(A<=x && B>=y)
	{
//		cout << x << " " << y << " " << "S[M] = " << S[M] << "sl = " << sl << "d = " << d <<" m = " << M << endl;
		return S[M]+sl*(((lint)(y-x))*(y-x))+((lint)2*d)*(y-x);
	}
	else if(B<=x || A>=y) return 0;
	else
	{
		int p = (x+y) / 2;
		//if(x+1 == y) return 
		return evalsegm(x,p,2*M,sl+ppp[M],d+sss[M]) + 
			evalsegm(p,y,2*M+1,sl+ppp[M],d+sss[M]+(p-x)*(sl+ppp[M]));
	}
}

int main(void)
{
	freopen("ROCKS.DAT","r",stdin);
	freopen("ROCKS.SOL","w",stdout);
//	ifstream in("ROCKS.DAT");
//	ofstream out("ROCKS.SOL");
	
	scanf("%d%d",&N,&L);//in >> N >> L;
	for(int i=0;i<N;i++)
	{
		scanf("%d",&op);//in >> op;
		if(op == 1)
		{
			scanf("%d%d",&X,&H);//in >> X >> H;
			addsegm(X-H,X,+1,0);
			addsegm(X,X+H,-1,H);
			printf("-1\n");//out << "-1\n";
		}
		else
		{
			scanf("%d%d",&A,&B);//in >> A >> B;
			printf("%.1f\n",(double)evalsegm(0,MAXL-1,1,0,0)/2);
		}
	}
//	cout << kol << " " << kol2;
	return 0;
}
