{ fp }

(* Problem:   unknown, work name CCC
 * Contest:   unknown
 * Type:      Solution
 * Author:    Ilya Porublyov
 * Date:      unknown
 * Language:  Pascal
 * Compiler:  Free Pascal 1.0.10
 * Algorithm: Recursive version of the best
 *)

{$R+,Q+,S+}
{$ifdef VER70}
{$M 65520,0,655360}
const MAXN=200;
type Int1=byte;
     Int2=integer;
{$else}
{$M $400000,0,655360}
const MAXN=1000;
type Int1=integer;
     Int2=longint;
{$endif}

type TDir4=0..3;
     TDir8=0..7;

{0 -- down, 1 -- right, 2 -- up, 3 -- left}
const dx:array[TDir4] of integer=(0,1,0,-1);
      dy:array[TDir4] of integer=(1,0,-1,0);
      dx8:array[TDir8] of integer=(0,1,1,1,0,-1,-1,-1);
      dy8:array[TDir8] of integer=(1,1,0,-1,-1,-1,0,1);

type TStack=array[1..MAXN*MAXN div 2] of 0..3;

var map:array[0..MAXN+1,0..MAXN+1] of char;
    N:integer;
    fv:text;
    STACK:TStack;
    RES_SQUARE:Int2;
    FILL_SQUARE:Int2;

procedure Fill__(y,x:Int1);
var ch:boolean;
    j,i:Int1;
    d:TDir8;
Begin
  map[y,x]:='*';
  inc(FILL_SQUARE);
  repeat
    ch:=false;
    for j:=N downto 1 do
      for i:=N downto 1 do
        for d:=7 downto 0 do
          if (map[j,i]='*') and (map[j+dy8[d],i+dx8[d]]<>'+') and (map[j+dy8[d],i+dx8[d]]<>'*') then begin
            ch:=true;
            map[j+dy8[d],i+dx8[d]]:='*';
            inc(FILL_SQUARE);
          end;
  until not ch;
End;

procedure Count_by_fill(top:Int2);
var i:Int2;
    the_x,the_y:Int1;
    res:Int2;
Begin
  res:=0;
  the_x:=1;
  the_y:=0;
  for i:=0 to N+1 do begin
    map[0,i]:='+';
    map[N+1,i]:='+';
    map[i,0]:='+';
    map[i,N+1]:='+';
  end;
  for i:=1 to top do begin
    the_y:=the_y+dy[STACK[i]];
    the_x:=the_x+dx[STACK[i]];
    map[the_y,the_x]:='+';
  end;
  FILL_SQUARE:=0;
  for i:=N downto 2 do begin
    if (map[i,1]<>'+') and (map[i,1]<>'*') then
      Fill__(i,1);
    if (map[i,N]<>'+') and (map[i,N]<>'*') then
      Fill__(i,N);
  end;
  FILL_SQUARE:=Int2(longint(N)*longint(N)-FILL_SQUARE);

End;

procedure CountSquare(top:Int2);
var i:Int2;
    the_y:Int1;
    res:Int2;
Begin
  res:=1;
  the_y:=0;
  for i:=1 to top do begin
    the_y:=the_y+dy[STACK[i]];
    case STACK[i] of
      1:res:=res+the_y;
      2:res:=res+1;
      3:res:=res-(the_y-1);
    end; {of case}
  end;
  RES_SQUARE:=res;

  write('    ',top:5,'    ');

  Count_by_fill(top);
End;

function fff(y_came,x_came:Int1;dir_came:TDir4;level:Int2):boolean;
var d,dd:byte;
Begin
  if map[y_came,x_came]<>'W' then begin
    fff:=false; exit
  end;
  STACK[level]:=dir_came;
  map[y_came,x_came]:='w';
  if (x_came=N)and(y_came=1) then begin
    CountSquare(level);
    fff:=true; exit
  end;
  for dd:=3 to 5 do begin
    d:=TDir4((byte(dir_came)+dd)mod 4);
    if fff(y_came+dy[d],x_came+dx[d],d,level+1) then begin
      fff:=true;
      exit;
    end;
  end;
  map[y_came,x_came]:='.';
  fff:=false;
End;

var i,j:integer;

    the_x,the_y:integer;

BEGIN
  assign(fv,'ccc.dat'); reset(fv);
  readln(fv,N);
  for i:=1 to N do begin
    for j:=1 to N do
      read(fv,map[i,j]);
    readln(fv);
  end;
  for i:=0 to N+1 do begin
    map[i,0]:='_';
    map[i,N+1]:='_';
  end;
  for j:=1 to N do begin
    map[0,j]:='_';
    map[N+1,j]:='_';
  end;

  fff(1,1,0,1);

  write(RES_SQUARE:6);
  write(FILL_SQUARE:6);

  if RES_SQUARE<>FILL_SQUARE then begin
    writeln('ATTENTION!!! RES_SQUARE<>FILL_SQUARE!!!');
    halt(1);
  end;

  assign(fv,'ccc.sol'); rewrite(fv);
  writeln(fv,RES_SQUARE);
  close(fv);

  halt(0)
END.
