{ fp }

(* Problem:   unknown, work name AAA
 * Contest:   unknown
 * Type:      Solution
 * Author:    Ilya Porublyov
 * Date:      unknown
 * Language:  Pascal
 * Compiler:  Free Pascal 1.0.10
 * Algorithm: Full-memoized, good-cut recursion 
		=> algorithm rather effective by time, 
		but uses huge memory
 *)

{$M $200000,0,$800000}
const MAXN=200;
      MAXM=200;
      MAXK=200;

type ResNum=extended;

{$R-,Q-,S-}

{
 -- memoized i i bbb_3.pas.

memoization '   'i, ⮬  ஧'燐
-⠪    ⨬쭨

I bbb_3.pas:

ਯ⨬,      室
1- १- . ண,    
㢠    ਬ 2- १- "---
i,  i,  㢠 ४. ॡi,
ᨬ쭮 ᪮㢠 ...

1)  1- १- . ண
2)   室 2- १- back-tracking,
஢ ॡi   שׁ,  类 㤮
⠡, i i⨭ i ॡ  :
"筠 㬠  类 諨  i⨭  
 i     i  \>K".
}


type TArr=array[0..MAXK] of ResNum;

var fv:text;
    mass:array[1..MAXM,1..MAXN] of byte;
    est:array[1..MAXM,1..MAXN] of longint;
    THE_M,THE_N,THE_K,i,j:byte;



    ans:array[1..MAXM,1..MAXN] of ^TArr;

    TOTAL_COUNT:ResNum;

function max(x,y:longint):longint;
Begin
  if x>y then max:=x else max:=y
End;

function min(x,y:longint):longint;
Begin
  if x<y then min:=x else min:=y
End;

var k_:byte;
function LookWaysTill(y,x:byte; sum:longint):ResNum;
Begin
  if (y=1) and (x=1) then begin
    LookWaysTill:=1; exit
  end;
  if (ans[y,x]<>nil) and (ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]<>-1.0) then begin
    LookWaysTill:=ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]; exit
  end;
  if ans[y,x]=nil then begin
    GetMem(ans[y,x],(THE_K+1)*sizeof(ResNum));
    for k_:=0 to THE_K do
      ans[y,x]^[k_]:=-1.0;
  end;
  ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]:=0;
  if (y>1) and (est[y-1,x]+sum >= est[THE_M,THE_N]-THE_K) then
{    ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]+=LookWaysTill(y-1,x,sum+mass[y-1,x]);}
    ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]] := ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]+
                                                          LookWaysTill(y-1,x,sum+mass[y-1,x]);
  if (x>1) and (est[y,x-1]+sum >= est[THE_M,THE_N]-THE_K) then
{    ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]+=LookWaysTill(y,x-1,sum+mass[y,x-1]);}
    ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]] := ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]]+
                                                          LookWaysTill(y,x-1,sum+mass[y,x-1]);
  LookWaysTill:=ans[y,x]^[est[THE_M,THE_N]-est[y,x]-sum+mass[y,x]];
End;

BEGIN

  writeln(sizeof(ans));
{$ifdef VER70}
  writeln(MemAvail);
{$endif}

  assign(fv,'aaa.dat'); reset(fv);
  readln(fv,THE_M,THE_N,THE_K);
  for i:=1 to THE_M do begin
    for j:=1 to THE_N do
      read(fv,mass[i,j]);
    readln(fv);
  end;
  close(fv);

  est[1,1]:=mass[1,1];
  for i:=2 to THE_M do
    est[i,1]:=est[i-1,1]+mass[i,1];
  for j:=2 to THE_N do
    est[1,j]:=est[1,j-1]+mass[1,j];

  for i:=2 to THE_M do
    for j:=2 to THE_N do
      est[i,j]:=max(est[i-1,j],est[i,j-1])+mass[i,j];

  for i:=1 to THE_M do
    for j:=1 to THE_N do
      ans[i,j]:=nil;


  TOTAL_COUNT:=LookWaysTill(THE_M,THE_N,longint(mass[THE_M,THE_N]));

{$ifdef VER70}
  writeln(MemAvail);
{$endif}

  for i:=1 to THE_M do
    for j:=1 to THE_N do
      if ans[i,j]<>nil then
        FreeMem(ans[i,j],(THE_K+1)*sizeof(ResNum));

  assign(fv,'aaa.sol'); rewrite(fv);
  writeln(fv,est[THE_M,THE_N]);
  writeln(fv,TOTAL_COUNT:0:0);
  close(fv);
END.
