{ fp }

(* Problem:   unknown, work name AAA
 * Contest:   unknown
 * Type:      Solution
 * Author:    Ilya Porublyov
 * Date:      unknown
 * Language:  Pascal
 * Compiler:  Free Pascal 1.0.10
 * Algorithm: Good-cut (but NOT memoized) recursion 
 *)

{$M $200000,0,$1000}

{$R-,Q-,S-}

{
ਯ⨬,      室 
1- १- . ண,     
㢠    ਬ 2- १- "--- 
i,  i,  㢠 ४. ॡi,
ᨬ쭮 ᪮㢠 ...

1)  1- १- . ண
2)   室 2- १- back-tracking,
஢ ॡi I שׁ,  类 㤮 
⠡, i i⨭ i ॡ  : 
"筠 㬠  类 諨  i⨭   
 i     i  \>K".
}

const MAXN=200;
      MAXM=200;
      MAXK=200;

var fv:text;
    mass:array[1..MAXN,1..MAXN] of byte;
    est:array[1..MAXN,1..MAXN] of longint;
    THE_M,THE_N,THE_K,i,j:byte;

    TOTAL_COUNT:extended;

function max(x,y:longint):longint;
Begin
  if x>y then max:=x else max:=y
End;

function min(x,y:longint):longint;
Begin
  if x<y then min:=x else min:=y
End;

function LookWaysTill(y,x:byte; sum:longint):extended;
var res:extended;
Begin
  if (y=1) and (x=1) then begin
    LookWaysTill:=1; exit
  end;
  res:=0;
  if (y>1) and (est[y-1,x]+sum >= est[THE_M,THE_N]-THE_K) then
    res:=res+LookWaysTill(y-1,x,sum+mass[y-1,x]);
  if (x>1) and (est[y,x-1]+sum >= est[THE_M,THE_N]-THE_K) then
    res:=res+LookWaysTill(y,x-1,sum+mass[y,x-1]);
  LookWaysTill:=res;
End;

BEGIN
  assign(fv,'aaa.dat'); reset(fv);
  readln(fv,THE_M,THE_N,THE_K);
  for i:=1 to THE_M do begin
    for j:=1 to THE_N do
      read(fv,mass[i,j]);
    readln(fv);
  end;
  close(fv);

  est[1,1]:=mass[1,1];
  for i:=2 to THE_M do
    est[i,1]:=est[i-1,1]+mass[i,1];
  for j:=2 to THE_N do
    est[1,j]:=est[1,j-1]+mass[1,j];

  for i:=2 to THE_M do
    for j:=2 to THE_N do
      est[i,j]:=max(est[i-1,j],est[i,j-1])+mass[i,j];


  TOTAL_COUNT:=LookWaysTill(THE_M,THE_N,longint(mass[THE_M,THE_N]));

  assign(fv,'aaa.sol'); rewrite(fv);
  writeln(fv,est[THE_M,THE_N]);
  writeln(fv,TOTAL_COUNT:0:0);
  close(fv);
END.
