{ bp }

(* Problem  : 	MATCHES
 * Contest  : 	UOI-2005 (Rovno)
 * Type     : 	Solution
 * Author   : 	Andrey Stasyuk
 * Language :	Pascal
 * Compiler :	Borland Pascal 7.0
 * Algorithm:	Optimal with time O(1)
 *)

const
  eps = 0.0000001;
var
  N, P: longint;
  root: real;
  fi, fo: text;

  function floor(what: real): longint;
  begin
    floor := trunc(what + eps);
  end;

  function ceil(what: real): longint;
  begin
    {bez +1 ne rabotaet dlya 0}
    if trunc(what - eps + 1) <> trunc(what + eps + 1) then
      ceil := trunc(what + eps)
    else
      ceil := trunc(what + eps) + 1;
  end;

begin
  assign(fi, 'matches.dat');
  reset(fi);
  assign(fo, 'matches.sol');
  rewrite(fo);

  readln(fi, N);
  root := sqrt(N);
  if N <= floor(root) * ceil(root) then
    P := 2 * floor(root) + 2 * ceil(root)
  else
  if N > floor(root)*ceil(root) then
    P := 4 * ceil(root);
  writeln(fo, N * 2 + P div 2);

  close(fi);
  close(fo);
end.